Subject: Re: [net-next v4 1/6] net: marvell: prestera: Add driver for Prestera family ASIC devices

From: Vadym Kochan <[email-masked]>
Date: Fri, 31 Jul 2020 23:55:33 +0300

Hi Andy,

On Fri, Jul 31, 2020 at 07:02:47PM +0300, Andy Shevchenko wrote:
> On Fri, Jul 31, 2020 at 6:22 PM Vadym Kochan <[email-masked]> wrote:
> > On Mon, Jul 27, 2020 at 03:59:13PM +0300, Andy Shevchenko wrote:
> > > On Mon, Jul 27, 2020 at 3:23 PM Vadym Kochan <[email-masked]> wrote:
> 
> ...
> 
> > > > Signed-off-by: Andrii Savka <[email-masked]>
> > > > Signed-off-by: Oleksandr Mazur <[email-masked]>
> > > > Signed-off-by: Serhiy Boiko <[email-masked]>
> > > > Signed-off-by: Serhiy Pshyk <[email-masked]>
> > > > Signed-off-by: Taras Chornyi <[email-masked]>
> > > > Signed-off-by: Volodymyr Mytnyk <[email-masked]>
> > > > Signed-off-by: Vadym Kochan <[email-masked]>
> > >
> > > This needs more work. You have to really understand the role of each
> > > person in the above list.
> > > I highly recommend (re-)read sections 11-13 of Submitting Patches.
> > >
> > At least looks like I need to add these persons as Co-author's.
> 
> I don't know, you are!
> And I think you meant Co-developer's
> 
> ...
> 
> > > > +#include <linux/string.h>
> > > > +#include <linux/bitops.h>
> > > > +#include <linux/bitfield.h>
> > > > +#include <linux/errno.h>
> > >
> > > Perhaps ordered?
> > >
> > alphabetical ?
> 
> Yes.
> 
> ...
> 
> > > > +       struct prestera_msg_event_port *hw_evt;
> > > > +
> > > > +       hw_evt = (struct prestera_msg_event_port *)msg;
> > >
> > > Can be one line I suppose.
> > >
> > Yes, but I am trying to avoid line-breaking because of 80 chars
> > limitation.
> 
> We have 100, but okay.
> 
> ...
> 
> > > > +       if (evt->id == PRESTERA_PORT_EVENT_STATE_CHANGED)
> > > > +               evt->port_evt.data.oper_state = hw_evt->param.oper_state;
> > > > +       else
> > > > +               return -EINVAL;
> > > > +
> > > > +       return 0;
> > >
> > > Perhaps traditional pattern, i.e.
> > >
> > >   if (...)
> > >     return -EINVAL;
> > >   ...
> > >   return 0;
> > >
> > I am not sure if it is applicable here, because the error state here
> > is if 'evt->id' did not matched after all checks. Actually this is
> > simply a 'switch', but I use 'if' to have shorter code.
> 
> Then do it a switch-case. I can see that other reviewers/contributors
> may stumble over this.
> 
> ...
> 
> > > > +       /* Only 0xFF mac addrs are supported */
> > > > +       if (port->fp_id >= 0xFF)
> > > > +               goto err_port_init;
> > >
> > > You meant 255, right?
> > > Otherwise you have to mentioned is it byte limitation or what?
> > >
> > > ...
> > Yes, 255 is a limitation because of max byte value.
> 
> But 255 itself is some kind of error value? Perhaps it deserves a definition.
> 
> ...
> 
> > > > +       np = of_find_compatible_node(NULL, NULL, "marvell,prestera");
> > > > +       if (np) {
> > > > +               base_mac_np = of_parse_phandle(np, "base-mac-provider", 0);
> > > > +               if (base_mac_np) {
> > > > +                       const char *base_mac;
> > > > +
> > > > +                       base_mac = of_get_mac_address(base_mac_np);
> > > > +                       of_node_put(base_mac_np);
> > > > +                       if (!IS_ERR(base_mac))
> > > > +                               ether_addr_copy(sw->base_mac, base_mac);
> > > > +               }
> > > > +       }
> > > > +
> > > > +       if (!is_valid_ether_addr(sw->base_mac)) {
> > > > +               eth_random_addr(sw->base_mac);
> > > > +               dev_info(sw->dev->dev, "using random base mac address\n");
> > > > +       }
> > >
> > > Isn't it device_get_mac_address() reimplementation?
> > >
> > device_get_mac_address() just tries to get mac via fwnode.
> 
> Yes, and how is it different from here? (consider
> fwnode_get_mac_address() if it suits better).
> 
In this case of_get_mac_address() tries to get mac address from
different sources:

    1) device-tree - if it is defined here

    2) nvmem device (eeprom) - if nvmem ref node was pointed in device-tree
       and nvmem provider has the mac address cell.

otherwise the driver will just use the random one.

> ...
> 
> > > > +       new_skb = alloc_skb(len, GFP_ATOMIC | GFP_DMA);
> > >
> > > Atomic? Why?
> > >
> > TX path might be called from net_tx_action which is softirq.
> 
> Okay, but GFP_DMA is quite a limitation to the memory region. Can't  be 32-bit?
> 
Yes in this case there are a limitation when the device supports only
30bit (this dma mask is used in prestera_pci.c), physical address range
even on 64bit platform.

And thankfully few months ago someone added such ability for RaspberryPI
(aarch64) to support ZONE_DMA.

> ...
> 
> > > > +       int tx_retry_num = 10 * tx_ring->max_burst;
> > >
> > > Magic!
> > You mean the code is magic ? Yes, I am trying to relax the
> > calling of SDMA engine.
> 
> Usually when reviewers tell you about magic it assumes magic numbers
> whose meaning is not clear.
> (Requires either to be defined or commented)
> 
> -- 
> With Best Regards,
> Andy Shevchenko